<?php
/*
 *  Copyright: (C) 2008 TutorialMS 
 *              
 *  This file is part of TutorialMS.							 
 *																			 
 * TutorialMS is free software: you can redistribute it   
 * and/or modify it under the terms of the GNU General    
 * Public License as published by the Free Software		 
 * Foundation, either version 3 of the License, or        
 * (at your option) any later version.							 
 *																			 
 * TutorialMS is distributed in the hope that it will be  
 * useful, but WITHOUT ANY WARRANTY; without even the     
 * implied warranty of MERCHANTABILITY or FITNESS FOR A  
 * PARTICULAR PURPOSE.  See the GNU General Public		    
 * License for more details.										 
 *																			 
 * You should have received a copy of the GNU General 	 
 * Public License along with TutorialMS.  					 
 * If not, see <http://www.gnu.org/licenses/>.            
*/
class XML_Manager {
		var $download_file_name = '';
		var $templatescount = 0;
		var $templatesdata = array();
		var $templatescode = array();
		var $csscount = 0;
		var $cssdata = array();
		var $csscode = array();
		var $stylevarscount = 0;
		var $stylevarsdata = array();
		var $stylevarscode = array();
		var $state = '';
	function startElementHandler ($parser, $name, $attrib){
		$this->state = $name;
		switch ($name) {
			case 'TemplateValue':
				$this->templatesdata[$this->templatescount]['TemplateName'] = $attrib['TemplateName'];
				$this->templatesdata[$this->templatescount]['TemplateLastEdited'] = $attrib['TemplateLastEdited'];
				$this->templatesdata[$this->templatescount]['TemplateLastEditor'] = $attrib['TemplateLastEditor'];
				break;
			case 'StyleVarsValue':
				$this->stylevarsdata[$this->stylevarscount]['StyleVarsName'] = $attrib['StyleVarsName'];
				$this->stylevarsdata[$this->stylevarscount]['StyleVarsDescription'] = $attrib['StyleVarsDescription'];
				break;
		}
	}
		
	function endElementHandler ($parser, $name){
		$this->state = '';
		if($name == 'TemplateValue') {
			$this->templatescount++;
		}elseif($name == 'CSSValue') {
			$this->csscount++;
		}elseif($name == 'StyleVarsValue') {
			$this->stylevarscount++;
		}
	}
	function characterDataHandler ($parser, $data) {
		if($this->state == 'TemplateValue') {
			if(!isset($this->templatescode[$this->templatescount])) {
				$this->templatescode[$this->templatescount] = '';
			}
			$this->templatescode[$this->templatescount] .= $data;
		}elseif($this->state == 'CSSValue') {
			if(!isset($this->csscode[$this->csscount])) {
				$this->csscode[$this->csscount] = '';
			}
			$this->csscode[$this->csscount] .= $data;
		}elseif($this->state == 'StyleVarsValue') {
			if(!isset($this->stylevarscode[$this->stylevarscount])) {
				$this->stylevarscode[$this->stylevarscount] = '';
			}
			$this->stylevarscode[$this->stylevarscount] .= $data;
		}
	}
	function parse_xml_file($xml_source, $xml_style_name) {
		$fp = fopen($xml_source, "r");
		$xml_parser = xml_parser_create();
		xml_parser_set_option ($xml_parser, XML_OPTION_CASE_FOLDING, false);
		xml_parser_set_option($xml_parser, XML_OPTION_SKIP_WHITE, 0);
		xml_set_element_handler($xml_parser, array(&$this, 'startElementHandler'), array(&$this, 'endElementHandler'));
		xml_set_character_data_handler($xml_parser, array(&$this, 'characterDataHandler'));
		$x = 0;
		while($data = fread($fp, 4096)){
			$x++;
			if(!xml_parse($xml_parser, $data, feof($fp))) {
				break;
			}
		}
		xml_parser_free($xml_parser);
		$temp = mysql_query("SHOW TABLE STATUS FROM `".DATABASE_NAME."` LIKE 'styles'") or die(mysql_error());
		$info = mysql_fetch_array($temp);
		$nextid = $info["Auto_increment"];
		mysql_query("INSERT INTO `styles`(`name`) VALUES('".$xml_style_name."')");
		$i = 0;
		while($i != $this->templatescount) {
			if($this->templatescode[$i] == '123PLACEHOLDER321') {
				mysql_query("INSERT INTO `templates`(`style_id`, `name`, `value`, `lastedited`, `lasteditor`) VALUES('".$nextid."', '".addslashes($this->templatesdata[$i]['TemplateName'])."', '', '".addslashes($this->templatesdata[$i]['TemplateLastEdited'])."', '".addslashes($this->templatesdata[$i]['TemplateLastEditor'])."')") or die(mysql_error());
			}else{
				mysql_query("INSERT INTO `templates`(`style_id`, `name`, `value`, `lastedited`, `lasteditor`) VALUES('".$nextid."', '".addslashes($this->templatesdata[$i]['TemplateName'])."', '".addslashes($this->templatescode[$i])."', '".addslashes($this->templatesdata[$i]['TemplateLastEdited'])."', '".addslashes($this->templatesdata[$i]['TemplateLastEditor'])."')") or die(mysql_error());			
			}
			$i++;
		}
		$i = 0;
		while($i != $this->csscount) {
			mysql_query("INSERT INTO `css`(`style_id`, `value`) VALUES('".$nextid."', '".addslashes($this->csscode[$i])."')") or die(mysql_error());
			$i++;
		}
		$i = 0;
		while($i != $this->stylevarscount) {
			mysql_query("INSERT INTO `stylevars`(`style_id`, `name`, `description`, `value`) VALUES('".$nextid."', '".addslashes($this->stylevarsdata[$i]['StyleVarsName'])."', '".addslashes($this->stylevarsdata[$i]['StyleVarsDescription'])."', '".addslashes($this->stylevarscode[$i])."')");
			$i++;
		}
	}
	function make_xml_file($style_id, $xml_file_name) {
		$xml = '<?xml version="1.0" encoding="UTF-8" ?>
		<style>
		';
		$xml .= '	<CSS>';
		$result = mysql_query("SELECT * FROM `css` WHERE `style_id`='".$style_id."'");
		while($row = mysql_fetch_array($result)) {
			$xml .= '		<CSSValue><![CDATA['.$row['value'].']]></CSSValue>
		';
		}
		$xml .= '	</CSS>
		';
		$xml .= '	<Templates>	
		';
		$result = mysql_query("SELECT * FROM `templates` WHERE `style_id`='".$style_id."'");
		while($row = mysql_fetch_array($result)) {
			if($row['value'] == '' ||preg_match('/^[\s]+$/', $row['value'])) {
				$xml .= '		<TemplateValue TemplateName="'.$row['name'].'" TemplateLastEdited="'.$row['lastedited'].'" TemplateLastEditor="'.$row['lasteditor'].'"><![CDATA[123PLACEHOLDER321]]></TemplateValue>
		';
			}else {
				$xml .= '		<TemplateValue TemplateName="'.$row['name'].'" TemplateLastEdited="'.$row['lastedited'].'" TemplateLastEditor="'.$row['lasteditor'].'"><![CDATA['.stripslashes($row['value']).']]></TemplateValue>
		';
			}
		}
		$xml .= '	</Templates>';
		$xml .= '	<StyleVars>	
		';
		$result = mysql_query("SELECT * FROM `stylevars` WHERE `style_id`='".$style_id."'");
		while($row = mysql_fetch_array($result)) {
			$xml .= '		<StyleVarsValue StyleVarsName="'.$row['name'].'" StyleVarsDescription="'.$row['description'].'"><![CDATA['.stripslashes($row['value']).']]></StyleVarsValue>
		';
		}
		$xml .= '	</StyleVars>
		</style>';
		$file = fopen($xml_file_name.'.xml', 'w+');
		fwrite($file, $xml);
		fclose($file);
		$full_file_name = $xml_file_name.'.xml';
		$this->download_file_name = $full_file_name;
	}
	function download_xml_style() {
		$filename = $this->download_file_name;
		ini_set('zlib.output_compression', 'Off');
		$fs = fopen($filename, "rb");
		header("Content-Type: application/force-download\n");
		header("Content-Disposition: attachment; filename=".$filename);
		$contents = fread($fs, filesize($filename));
		echo $contents;
		fclose($fs);
	}
}
?>