<?php
/*
 *  Copyright: (C) 2008 TutorialMS 
 *              
 *  This file is part of TutorialMS.							 
 *																			 
 * TutorialMS is free software: you can redistribute it   
 * and/or modify it under the terms of the GNU General    
 * Public License as published by the Free Software		 
 * Foundation, either version 3 of the License, or        
 * (at your option) any later version.							 
 *																			 
 * TutorialMS is distributed in the hope that it will be  
 * useful, but WITHOUT ANY WARRANTY; without even the     
 * implied warranty of MERCHANTABILITY or FITNESS FOR A  
 * PARTICULAR PURPOSE.  See the GNU General Public		    
 * License for more details.										 
 *																			 
 * You should have received a copy of the GNU General 	 
 * Public License along with TutorialMS.  					 
 * If not, see <http://www.gnu.org/licenses/>.            
*/

function check_modrewrite($option) {
	switch($option) {
		case 'file':
			echo 'Checking if .htaccess exists ...<br />';
			if(is_file('../.htaccess')) {
				echo '<span class="valid">Exists!</span><br />';			
			}else{
				echo '<span class="warn">.htaccess does not exist! This means that enabling MOD-Rewrite will not work, either upload .htaccess or do not enable MOD-Rewrite</span><br />';
			}
			break;
	}
}

function check_dirs($name) {
	switch($name) {
		case 'avatars':
			echo 'Checking permissions for images/avatars/ ...<br />';
			if(!is_writable("../images/avatars/")) {
				// attempt to fix automatically
				if(!chmod("../images/avatars/", "0777")) {
					echo '<span class="error">Not writable! Warning give the directory "images/avatars/" full permissions and refresh this page.</span><br />';			
				}else{
					echo '<span class="valid">Writable!</span><br />';
				}
			}else{
				echo '<span class="valid">Writable!</span><br />';
			}
			break;
		case 'default_avatars':
			echo 'Checking permissions for images/default_avatars/ ...<br />';
			if(!is_writable("../images/default_avatars/")) {
				// attempt to fix automatically
				if(!chmod("../images/default_avatars/", "0777")) {
					echo '<span class="error">Not writable! Warning give the directory "images/default_avatars/" full permissions and refresh this page.</span><br />';			
				}else{
					echo '<span class="valid">Writable!</span><br />';
				}
			}else{
				echo '<span class="valid">Writable!</span><br />';
			}
			break;
		case 'icons':
			echo 'Checking permissions for images/icons/ ...<br />';
			if(!is_writable("../images/icons/")) {
				// attempt to fix automatically
				if(!chmod("../images/icons/", "0777")) {
					echo '<span class="error">Not writable! Warning give the directory "images/icons/" full permissions and refresh this page.</span><br />';			
				}else{
					echo '<span class="valid">Writable!</span><br />';
				}
			}else{
				echo '<span class="valid">Writable!</span><br />';
			}
			break;
		case 'tutorial_images':
			echo 'Checking permissions for images/tutorial_images/ ...<br />';
			if(!is_writable("../images/tutorial_images/")) {
				// attempt to fix automatically
				if(!chmod("../images/tutorial_images/", "0777")) {
					echo '<span class="error">Not writable! Warning give the directory "images/tutorial_images/" full permissions and refresh this page.</span><br />';			
				}else{
					echo '<span class="valid">Writable!</span><br />';
				}
			}else{
				echo '<span class="valid">Writable!</span><br />';			
			}
			break;
		}
}

function check_ajax() {
	echo 'Checking "root" variable in ajax.js ...<br />';
	$path = '../ajax.js';
	$code = file_get_contents($path);
	preg_match_all('/var root = \'(.*)\';/Ui', $code, $matches);
	$value = $matches[1][0];
	$url = $_SERVER['HTTP_HOST'] . $_SERVER['PHP_SELF'];
	$should_be_value = strstr(substr($url, 0, -19), '/');
	if($value != $should_be_value) {
		echo '<span class="error">Invalid! You need to change the value of var root in ajax.js to "'.$should_be_value.'".</span><br />';			
	}else{
		echo '<span class="valid">Valid</span><br />';
	}
}

function custom_data($site_name, $http_server, $mod_rewrite, $admin_email, $username, $pass) {
	mysql_query("INSERT INTO `admin` (`name`, `password`, `privileges`) VALUES ('".$username."', '".$pass."', '1:1:1:1:1:1:1:1:1:1:1')");
	mysql_query("INSERT INTO `config` (`constant`, `value`, `description`) VALUES ('COMPANY_NAME', '".$site_name."', 'Name of the site.')");
	mysql_query("INSERT INTO `config` (`constant`, `value`, `description`) VALUES ('HTTP_SERVER', '".$http_server."', 'Root directory of the server.')");
	mysql_query("INSERT INTO `config` (`constant`, `value`, `description`) VALUES ('MOD_REWRITE_ON', '".$mod_rewrite."', 'True if Mod_Rewrite is on, otherwise false.')");
	mysql_query("INSERT INTO `config` (`constant`, `value`, `description`) VALUES ('ADMIN_EMAIL', '".$admin_email."', 'The email address of the admin -- recieves the email from \"Contact Us\"')");
}

function default_data() {
	// insert default data required to run the script
	mysql_query("INSERT INTO `affiliate_in_hits` VALUES (-1, '0', '0', '".date('F')."')");
	mysql_query("INSERT INTO `affiliate_out_hits` VALUES (-1, '0', '".date('F')."')");
	mysql_query("INSERT INTO `announcements` (`title`, `text`, `link`, `date`) VALUES('Welcome to TutorialMS 1.4', 'You have just installed TutorialMS and can now start customizing, or adding tutorials to it. Feel free to visit our forum to for support, report bugs, or to just join the community.', 'http://www.tutorialms.com', ".time().")");
	mysql_query("INSERT INTO `tutorial_front` VALUES(1, 'default', 'TutorialMS was installed sucsesfully - Visit our Forums for Support', 0, 0, 0, 'tutorialms.com', 'Dummy Category', 'Example', 'http://www.tutorialms.com/forum/',  ".time().", 1, 0, 0, 0)");
	mysql_query("INSERT INTO `navigation` VALUES(1, 'images/icons/1.jpg', 'Dummy Category', 'images/default_avatars/1.jpg')");
	mysql_query("INSERT INTO `sub_categories` VALUES(1, 'Example', 'Dummy Category')");
	mysql_query("INSERT INTO `affiliates` (`id`, `name`, `link`, `out`, `in`) VALUES (1, 'TutorialMS', 'http://www.tutorialms.com', 0, 0);");
	mysql_query("INSERT INTO `config` (`constant`, `value`, `description`) VALUES ('NUMBER_TOP_TUTORIALS', '3', 'Number of Top Tutorials to show.')");
	mysql_query("INSERT INTO `config` (`constant`, `value`, `description`) VALUES ('NUMBER_LATEST_TUTORIALS', '10', 'Number of Latest Tutorials to show.')");
	mysql_query("INSERT INTO `config` (`constant`, `value`, `description`) VALUES ('NUMBER_SUBMIT_TUTORIALS', '25', 'Number of tutorials a user can submit at once.')");
	mysql_query("INSERT INTO `config` (`constant`, `value`, `description`) VALUES ('NUMBER_MAX_ICON_SIZE', '10240', 'Maximum size of Tutorial Avatars. (bytes)')");
	mysql_query("INSERT INTO `config` (`constant`, `value`, `description`) VALUES ('NUMBER_DIMENSIONS_W', '60', 'Maximum width of an Avatar.')");
	mysql_query("INSERT INTO `config` (`constant`, `value`, `description`) VALUES ('NUMBER_DIMENSIONS_H', '60', 'Maximum height of an Avatar.')");
	mysql_query("INSERT INTO `config` (`constant`, `value`, `description`) VALUES ('NUMBER_ROWS_PER_PAGE', '15', 'Maximum tutorials to show when navigating.')");
	mysql_query("INSERT INTO `config` (`constant`, `value`, `description`) VALUES ('NUMBER_AFFILIATES_SHOW', '3', 'The number of affiliates to show.')");
	mysql_query("INSERT INTO `config` (`constant`, `value`, `description`) VALUES ('CONTACT_US_SUBJECTS', 'Affiliation;Business Related;Report an Error;Other', 'The subjects for the Contact Us page. (seperate by semi-colons)')");
	mysql_query("INSERT INTO `config` (`constant`, `value`, `description`) VALUES ('CURRENT_STYLE_ID', '1', 'The current style that your site will use.')");
	mysql_query("INSERT INTO `config` (`constant`, `value`, `description`) VALUES ('CURRENT_VERSION', '1.4', 'The version of the currently installed TutorialMS.')");
	mysql_query("INSERT INTO `config` (`constant`, `value`, `description`) VALUES ('APPROVAL_TIME', '60', 'The amount of time (seconds) between each tutorial is activated from the approval que.')");
	mysql_query("INSERT INTO `config` (`constant`, `value`, `description`) VALUES ('NUMBER_ANNOUNCEMENTS_SHOW', '3', 'The number of announcements to show.')");
	mysql_query("INSERT INTO `config` (`constant`, `value`, `description`) VALUES ('TUTORIAL_FRAME', '2', '1 if you want a tutorial frame over tutorials on other sites, if not then enter 2.')");
	mysql_query("INSERT INTO `people_online` VALUES (-1, '0', 0, 0);");
	mysql_query("INSERT INTO `searches` VALUES (-1, '0', 0, '".date('d/m/y')."');");
	mysql_query("INSERT INTO `help` VALUES(1, 'Submiting Tutorials', 'How do I submit tutorials?', 'You can simply visit the \"submit\" page and there you can select a category and the amount for the tutorials you are submitting. You will have to submit again if you would like to submit tutorials under a different category.');");
	mysql_query("INSERT INTO `help` VALUES(2, 'Submiting Tutorials', 'I just submitted my tutorials but I don''t see them on the site!', 'When tutorials are submitted they are sent to an \"approval que\" where they have to be approved by an administrator, this may take a few hours or it make take a few days, it all depends on how active and how busy the administrator is.');");
	mysql_query("INSERT INTO `help` VALUES(3, 'Submiting Tutorials', 'My tutorials aren''t getting approved!', 'It is possible that your tutorials are being declined, this could be because of several reasons but it really varies from site to site (since the administrators may have different expectations). Although some basic rules to follow are:\r\n\r\n- Make sure that your tutorial doesn\'t require registration to view.\r\n- It isn\'t a duplicate (a topic that is already covered by another tutorial on this site)\r\n- It is a quality tutorial (will vary from site to site).');");
	mysql_query("INSERT INTO `help` VALUES(4, 'Submiting Tutorials', 'I uploaded my own avatar but the avatar wasn''t the one I uploaded?', 'This may have happened because the avatar didn''t follow the avatar rules, they are at the top of the submit page. If the avatar doesn\'t follow the rules then it will just be replaced with a default avatar. Make sure you get the right file type and file size.');");
	mysql_query("INSERT INTO `help` VALUES(5, 'Submiting Tutorials', 'When I submit tutorials, how come they don''t always succeed?', 'This could be caused by many problems, but make sure the URLs submitted are valid, and include \"http://\". Also, make sure you fill everything out and that the link is not already in the database.');");
	mysql_query("INSERT INTO `help` VALUES(6, 'Interacting with Tutorials', 'How do I rate a tutorial?', 'To rate a tutorial, click one of the five stars in the listing for that specific tutorial. The stars are in order from left to right, with left being the lowest and right being the highest.');");
	mysql_query("INSERT INTO `help` VALUES(7, 'Interacting with Tutorials', 'What do I do if a tutorial I go to doesn''t work?', 'If you visit a tutorial and the tutorial isn''t there because it was deleted or the site is gone, then just go back to the tutorial listing and click the link \"Dead Link\" and the administrator can see the report in the admin panel.');");
	mysql_query("INSERT INTO `help` VALUES(8, 'Interacting with Tutorials', 'What is this link that says \"More\" do?', 'This will go to a page that lists all the tutorials by the site who made tutorial that you had the \"More\" link on it. This is useful if you like the site''s writing style or want to find out what other categories the site has.');");
	mysql_query("INSERT INTO `help` VALUES(10, 'Finding Tutorials', 'How do I search for tutorials?', 'By default there is a search bar at the top right part of the page. You can type your search there and hit enter. Additionally, there is search boxes on pages that list the tutorials for a specific category.');");
	mysql_query("INSERT INTO `help` VALUES(11, 'Finding Tutorials', 'How do I sort tutorials?', 'There is a sorting feature every page that lists the tutorials for a specific category. Also, if you make a search you will see the sorting feature which you can use, while keeping the search keywords.');");
	mysql_query("INSERT INTO `help` VALUES(12, 'Submiting Tutorials', 'Do I need to register to submit a tutorial?', 'No, you do not need to register to submit tutorials, cast votes, report dead links, view tutorials etc.');");
	mysql_query("INSERT INTO `help` VALUES(13, 'Submiting Tutorials', 'Can I edit the submitted tutorial(s) after they are submitted?', 'No, if there is something wrong then either contact the administrator or submit it again.');");
	mysql_query("INSERT INTO `help` VALUES(14, 'Submiting Tutorials', 'What's the \'avatar\' for?', 'The avatar is not neccissarry for each tutorial you submit because there will be a default avatar for the category you are submitting to. Although, avatars are useful because you can then make your tutorial stand more and/or give an example of the tutorial.');");
	mysql_query("INSERT INTO `help` VALUES(15, 'Submiting Tutorials', 'How long does it take for a tutorial to be approved?', 'There is no set period of time that it will take to approve your tutorial, if it is approved at all. It will most likely depend on how many tutorials are in the Approval Que and how often the administrator approves tutorials.');");
	
	mysql_query("INSERT INTO `help_categories` VALUES (1, 'Submiting Tutorials');");
	mysql_query("INSERT INTO `help_categories` VALUES (2, 'Interacting with Tutorials');");
	mysql_query("INSERT INTO `help_categories` VALUES (3, 'Finding Tutorials');");
}

function make_tables() {
	// build the tables in MySQL
	// just structure, no data
	mysql_query("CREATE TABLE IF NOT EXISTS `admin` (
	  `id` int(5) NOT NULL auto_increment,
	  `name` varchar(15) NOT NULL default '',
	  `password` varchar(50) NOT NULL default '',
	  `privileges` varchar(50) NOT NULL default '0',
	  PRIMARY KEY  (`id`)
	) ENGINE=MyISAM  DEFAULT CHARSET=latin1;");
	
	mysql_query("CREATE TABLE IF NOT EXISTS `affiliates` (
	  `id` int(15) NOT NULL auto_increment,
	  `name` varchar(50) NOT NULL default '',
	  `link` varchar(100) NOT NULL default '',
	  `out` int(15) NOT NULL default '0',
	  `in` int(15) NOT NULL default '0',
	  PRIMARY KEY  (`id`)
	) ENGINE=MyISAM  DEFAULT CHARSET=latin1;");
	
	mysql_query("CREATE TABLE IF NOT EXISTS `affiliate_in_history` (
	  `id` varchar(5) NOT NULL default '',
	  `months` varchar(200) NOT NULL default '',
	  `year` varchar(4) NOT NULL default ''
	) ENGINE=MyISAM DEFAULT CHARSET=latin1;");
	
	mysql_query("CREATE TABLE IF NOT EXISTS `affiliate_in_hits` (
	  `id` int(5) NOT NULL default '0',
	  `ip` varchar(50) NOT NULL default '',
	  `refurl` varchar(100) NOT NULL default '',
	  `cur_month` varchar(20) default NULL
	) ENGINE=MyISAM DEFAULT CHARSET=latin1;");
	
	mysql_query("CREATE TABLE IF NOT EXISTS `affiliate_out_history` (
	  `id` varchar(5) NOT NULL default '',
	  `months` varchar(200) NOT NULL default '',
	  `year` varchar(4) NOT NULL default ''
	) ENGINE=MyISAM DEFAULT CHARSET=latin1;");
	
	mysql_query("CREATE TABLE IF NOT EXISTS `affiliate_out_hits` (
	  `id` int(5) NOT NULL default '0',
	  `ip` varchar(50) NOT NULL default '',
	  `cur_month` varchar(20) default NULL
	) ENGINE=MyISAM DEFAULT CHARSET=latin1;");
	
	mysql_query("CREATE TABLE IF NOT EXISTS `announcements` (
	  `id` int(10) NOT NULL auto_increment,
	  `title` varchar(50) NOT NULL default '',
	  `text` text NOT NULL,
	  `link` varchar(100) NOT NULL default '',
	  `date` int(11) NOT NULL default '0',
	  PRIMARY KEY  (`id`)
	) ENGINE=MyISAM  DEFAULT CHARSET=latin1;");
	
	mysql_query("CREATE TABLE IF NOT EXISTS `comments` (
	  `id` int(11) NOT NULL auto_increment,
	  `userid` int(11) NOT NULL,
	  `tutid` int(11) NOT NULL,
	  `comment` text NOT NULL,
	  `date` int(10) NOT NULL,
	  PRIMARY KEY  (`id`)
	) ENGINE=MyISAM  DEFAULT CHARSET=latin1;");
	
	mysql_query("CREATE TABLE IF NOT EXISTS `config` (
	  `constant` varchar(100) NOT NULL default '',
	  `value` varchar(100) NOT NULL default '',
	  `description` varchar(100) NOT NULL default ''
	) ENGINE=MyISAM DEFAULT CHARSET=latin1;");
	
	mysql_query("CREATE TABLE IF NOT EXISTS `css` (
	  `style_id` int(11) NOT NULL default '0',
	  `value` text NOT NULL
	) ENGINE=MyISAM DEFAULT CHARSET=latin1;");
	
	mysql_query("CREATE TABLE IF NOT EXISTS `deadlink` (
	  `id` int(10) NOT NULL default '0',
	  `ip` varchar(50) NOT NULL default ''
	) ENGINE=MyISAM DEFAULT CHARSET=latin1;");
	
	mysql_query("CREATE TABLE IF NOT EXISTS `feeds` (
	  `userid` int(11) NOT NULL,
	  `feedtype` enum('dead','vote','register','wrote','comment','submit') NOT NULL,
	  `title` varchar(50) NOT NULL,
	  `tutid` int(10) default '0',
	  `comment` varchar(35) default NULL,
	  `date` int(10) NOT NULL,
	  `vote` int(2) default NULL
	) ENGINE=MyISAM DEFAULT CHARSET=latin1;");
	
	mysql_query("CREATE TABLE IF NOT EXISTS `help` (
	  `id` int(11) NOT NULL auto_increment,
	  `category` varchar(100) NOT NULL default '',
	  `questions` varchar(100) NOT NULL default '',
	  `answers` text NOT NULL,
	  PRIMARY KEY  (`id`)
	) ENGINE=MyISAM  DEFAULT CHARSET=latin1;");
	
	mysql_query("CREATE TABLE IF NOT EXISTS `help_categories` (
	  `id` int(11) NOT NULL auto_increment,
	  `name` varchar(100) NOT NULL default '',
	  PRIMARY KEY  (`id`)
	) ENGINE=MyISAM  DEFAULT CHARSET=latin1;");
	
	mysql_query("CREATE TABLE IF NOT EXISTS `navigation` (
	  `id` int(5) NOT NULL auto_increment,
	  `icon` varchar(100) NOT NULL default '',
	  `name` varchar(30) NOT NULL default '',
	  `default_tut_icons` varchar(100) NOT NULL default '',
	  PRIMARY KEY  (`id`)
	) ENGINE=MyISAM  DEFAULT CHARSET=latin1;");
	
	mysql_query("CREATE TABLE IF NOT EXISTS `people_online` (
	  `id` int(5) NOT NULL default '0',
	  `ip` varchar(50) NOT NULL default '',
	  `activity` int(20) NOT NULL default '0',
	  `most_online` int(10) default '0'
	) ENGINE=MyISAM DEFAULT CHARSET=latin1;");
	
	mysql_query("CREATE TABLE IF NOT EXISTS `searches` (
	  `id` int(20) NOT NULL auto_increment,
	  `search` varchar(40) NOT NULL default '',
	  `amount` int(40) NOT NULL default '0',
	  `since` varchar(10) default NULL,
	  PRIMARY KEY  (`id`)
	) ENGINE=MyISAM  DEFAULT CHARSET=latin1 PACK_KEYS=1;");
	
	mysql_query("CREATE TABLE IF NOT EXISTS `styles` (
	  `id` int(11) NOT NULL auto_increment,
	  `name` varchar(100) NOT NULL default '',
	  PRIMARY KEY  (`id`)
	) ENGINE=MyISAM  DEFAULT CHARSET=latin1 PACK_KEYS=0;");
	
	mysql_query("CREATE TABLE IF NOT EXISTS `stylevars` (
	  `style_id` int(11) NOT NULL default '0',
	  `name` varchar(30) NOT NULL default '',
	  `description` text NOT NULL,
	  `value` varchar(100) NOT NULL default ''
	) ENGINE=MyISAM DEFAULT CHARSET=latin1;");
	
	mysql_query("CREATE TABLE IF NOT EXISTS `sub_categories` (
	  `id` int(11) NOT NULL auto_increment,
	  `name` varchar(50) NOT NULL default '',
	  `categorey` varchar(50) NOT NULL default '',
	  PRIMARY KEY  (`id`)
	) ENGINE=MyISAM  DEFAULT CHARSET=latin1;");
	
	mysql_query("CREATE TABLE IF NOT EXISTS `templates` (
	  `style_id` int(11) NOT NULL default '0',
	  `name` varchar(30) NOT NULL default '',
	  `value` longtext NOT NULL,
	  `lastedited` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
	  `lasteditor` varchar(30) NOT NULL
	) ENGINE=MyISAM DEFAULT CHARSET=latin1 PACK_KEYS=0;");
	
	mysql_query("CREATE TABLE IF NOT EXISTS `tutorial` (
	  `id` varchar(10) NOT NULL default '',
	  `text` longtext NOT NULL,
	  `author` varchar(15) NOT NULL default '',
	  `views` int(25) NOT NULL default '0'
	) ENGINE=MyISAM DEFAULT CHARSET=latin1;");
	
	mysql_query("CREATE TABLE IF NOT EXISTS `tutorial_front` (
  `id` int(11) NOT NULL auto_increment,
  `icon` varchar(100) NOT NULL default 'default',
  `tutname` varchar(100) NOT NULL default '',
  `rating` int(5) NOT NULL default '0',
  `votes` int(5) NOT NULL default '0',
  `views` int(7) NOT NULL default '0',
  `source` varchar(50) NOT NULL default '',
  `mcate` varchar(30) NOT NULL default '',
  `scate` varchar(30) NOT NULL default 'All',
  `link` text,
  `date` int(20) default NULL,
  `approved` int(1) NOT NULL default '0',
  `custom_tutorial` int(1) NOT NULL default '0',
  `que` int(1) NOT NULL default '0',
  `user` varchar(20) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 PACK_KEYS=0");
	
	mysql_query("CREATE TABLE IF NOT EXISTS `users` (
	  `id` int(11) NOT NULL auto_increment,
	  `username` varchar(20) NOT NULL,
	  `password` varchar(32) NOT NULL,
	  `registered` int(10) NOT NULL,
	  `lastseen` int(10) NOT NULL,
	  PRIMARY KEY  (`id`)
	) ENGINE=MyISAM  DEFAULT CHARSET=latin1;");
	
	mysql_query("CREATE TABLE IF NOT EXISTS `votes` (
	  `tut_id` int(10) NOT NULL default '0',
	  `ip` varchar(40) NOT NULL default ''
	) ENGINE=MyISAM DEFAULT CHARSET=latin1;");
	
	mysql_query("ALTER TABLE `tutorial_front` ADD FULLTEXT (`tutname`)");
}

function make_default_style() {
	require("../admin/includes/xml_functions.php");
	$style = new XML_Manager;
	$style->parse_xml_file('../admin/includes/default_style.xml', 'TutorialMS Default Style');
}

function check_slashes($value, $remove=1) {
	if($remove == 1) {
		if(get_magic_quotes_gpc() != 1) {
			return addslashes($value);
		}
	}else{
		if(get_magic_quotes_gpc() == 1) {
			return stripslashes($value);
		}
	}
	return $value;
}

?>